<?php
##############################################################################
# G5-Scripts.de PHP Newsletter Script
# Copyright 2004-2013 G5-Scripts.de webmaster@G5-Scripts.de
# Last Modified                04.01.2013
# G5-Scripts.de                http://www.G5-Scripts.de
# Version                      1.2.7
##############################################################################
# Lizenzbedingungen (gekürzte Fassung)
# Copyright 2004-2013 G5-Scripts.de  All Rights Reserved.
# 
# Mit dem Herunterladen bzw. Erwerb der hier angebotenen Software erkennen die Nutzer 
# ausdrücklich die Lizenzbestimmungen gelesen und diese anerkannt zu haben.
#
# Beim Einsatz der Software im rein privaten Bereich ohne kommerzielle oder gewerbliche Absicht, 
# ist die Software für die Nutzung kostenfrei. Für die kommerzielle Nutzung sowie 
# eine optionale Entfernung des Copyright Hinweises ist eine geeignete Lizenz zu erwerben.
#
# Diese Software darf im rein privaten Bereich frei benutzt werden, 
# solange alle Copyright bzw. Powered By Verweise auf G5-Scripts.de, 
# eingebaut innerhalb der Software, erhalten bleibt. Diese müssen für Benutzer sichtbar sein 
# und in unveränderter Form dargestellt werden.
#
# Die Original-Software unver&auml;ndert darf weitergegeben, jedoch nicht verkauft
# oder wiederverkauft werden.
# Die angepasste bzw. ver&auml;nderte Software und Teile dieser d&uuml;rfen nicht
# weitergegeben, verkauft oder wiederverkauft werden.
#
# Die vollständige Fassung der Lizenzbedingungen finden Sie unter:
# http://www.g5-scripts.de/scripte__newsletter_php__lizenzbedingungen.htm
#
##############################################################################

define("RELEASEDATE", "04.01.2013");
define("VERSION", "1.2.7");
//error_reporting(E_ALL ^ E_NOTICE);
//error_reporting(E_ERROR | E_WARNING | E_PARSE | E_NOTICE);
error_reporting(E_ALL);

mb_internal_encoding('UTF-8');
mb_http_output('UTF-8');


ignore_user_abort(true);
clearstatcache();
if(file_exists("variablen.php")){include("variablen.php");}
if(file_exists("kategorien.php")){include("kategorien.php");}
if(file_exists("subs.php")){include("subs.php");}
if(file_exists("letter.php")){include("letter.php");}

$ISDEMO = IsDemo();

$in = init_cgi();
$cat = getCategories();

LoadPlugins();


if($in["ac"] == "setup"   )			{setup();}
elseif($in["ac"] == "store_vars")   {store_vars($in);}
elseif($in["ac"] == "kategorien")   {kategorien($in);}
elseif($in["ac"] == "abonnenten")   {abonnenten($in);}
elseif($in["ac"] == "email_templ")  {email_templ($in);}
elseif($in["ac"] == "neue_newsletter"){neue_newsletter($in);}
elseif($in["ac"] == "letterarchiv") {letterarchiv($in);}
elseif($in["ac"] == "dele_letter")  {dele_letter($in);}
elseif($in["ac"] == "show_letter")  {show_letter($in);}
elseif($in["ac"] == "new_cat")      {new_cat($in,0);}
elseif($in["ac"] == "ch_cat")       {new_cat($in,"ch");}
elseif($in["ac"] == "dele_cat")     {dele_cat($in['cat']);}
elseif($in["ac"] == "plugins")      {plugins($in);}	
elseif($in["ac"] == "password")     {password($in);}
elseif($in["ac"] == "ch_pass")      {ch_pass($in);}

elseif($in["ac"] == "saveLetter")   {saveLetter($in);}
elseif($in["ac"] == "send_letter_admin") {send_letter_admin($in);}
elseif($in["ac"] == "send_letter_user") {
	if(sendLetterToUser($in['email'], $in['cat'], $in['nslID']))
		echo $in['email'];
	else
		echo '';
}

else {start();}


function start() {
	global $script_url, $script_pfad, $cat;
	
	site_header("Startseite", "Home16");
	
	$version = VERSION;
	$viSuccess = true;
	if(isset($script_url)){
		if(class_exists("NSLVersionInfo", false)){
			$vi = new NSLVersionInfo(VERSION);
			$viSuccess = $vi->Load();
		}
	}
	
	print '
		<div class="content" id="jQueryTest">
			<div class="caption">JavaScript Test</div>
			<div class="red">Sie ben&ouml;tigen einen JavaScript f&auml;higen Browser um dieses Script im vollen Umpfang nutzen zu k&ouml;nnen.</div>
		</div>
		';
	if(ini_get('safe_mode') && strtolower(ini_get('safe_mode')) == 'on'){
		print '
			<div class="content">
				<div class="caption">PHP Safe Mode Einschr&auml;nkung</div>
				<div class="red">
				Auf Ihrem Server ist PHP Safe Mode aktiviert. F&uuml;r eine reibungslose Funktionalit&auml;t des Scripts muss das PHP Safe Mode deaktiviert sein. 
				Bitte wenden Sie sich hierzu an Ihren Server Administrator.
				</div>
			</div>
		';
	}
	
	if(!isset($script_url) || strlen($script_url) == 0 || !isset($script_pfad) || strlen($script_url) == 0)
	{
		print '
		<div class="content">
			<div class="caption">Willkommen!</div>
			<div>
			Bitte treffen Sie als n&auml;chstes Ihre Einstellungen unter <b>Script Optionen</b> oben links im Men&uuml;.<br>
			Alle &uuml;brigen Men&uuml;punkte werden erst nach diesen Einstellungen eingeblendet.<br>
			<br>
			</div>
		</div>
		';
	}
	else if(!isset($cat)){
		print '
		<div class="content">
			<div class="caption">Bitte Kategorien anlegen</div>
			<div>
			Bitte legen Sie als n&auml;chstes eine oder mehrere Kategorien an. Sie m&uuml;ssen mindestens eine Kategorie anlegen. 
			<br>
			</div>
		</div>
		';
	}
	//if(isset($script_url) && strlen($script_url) > 0 && isset($script_pfad) && strlen($script_url) > 0)
	else
	{
		if(class_exists("NSLNoCopyright", false)){
			$nocopy = new NSLNoCopyright();
			$nocopy->Check();
		}
		print '
			<div class="content">
				<div class="caption">Newsletter An- / Abmeldemaske</div>
				<div>
				Unter der folgenden URL finden Sie das Newsletter Anmelde Formular f&uuml;r Ihre Besucher / Interessenten.<br>
				<a href="'.$script_url.'/newsletter.php">'.$script_url.'/newsletter.php</a>
				<br><br>
				Einbaum&ouml;glichkeiten: <a id="einbaumoeglichkeitenLink">hier klicken</a>
				</div>
			</div>
			<div class="content" id="einbaumoeglichkeiten">
				<div class="caption">Einbaum&ouml;glichkeiten</div>
				<div><strong><i>Einbau per JavaScript:</i></strong></div>
				<div class="code">Ihre Webseite &gt&gt<br>.....<br>&lt;script src=&quot;'.$script_url.'/newsletter.php?showin=java&quot; type=&quot;text/javascript&quot;&gt;&lt;/script&gt;<br>.....</div>
				<br>
				<div><strong><i>Einbau per PHP Include:</i></strong></div>
				<div class="code">Ihr PHP Script &gt&gt<br>.....<br>include("'.$script_pfad.'/newsletter.php");<br>.....</div>
			</div>
			<div id="startseiteAppArea"></div>
			';
		
		if($viSuccess){
			if(class_exists("NSLVersionInfo", false)){
				if(strlen($vi->version) > 0){
					print '
					<div class="content" id="versionInfo">
						<div class="caption">Versions-Informationen</div>
						<div class="red">Sie sind nicht mehr auf dem neusten Stand!</div>
						<div>Folgende Versions&auml;nderungen haben Sie verpasst:<br>
						'.$vi->version.'
						</div>
					</div>
					';
				}else{
					print '
					<div class="content" id="versionInfo">
						<div class="caption">Versionsinfos</div>
						<div class="green">Sie sind auf dem neusten Stand!</div>
					</div>
					';
				}
				
				print '
				<div class="content" id="plugInsInfo">
					<div class="caption">Verf&uuml;gbare Plugins / Module</div>
					'.$vi->plugin.'
					
					<div id="plugInsLegend">
					<table>
					<tr>
					<td width="10" style="background: green"></td><td>installiert</td>
					<td width="10" style="background: red"></td><td>nicht installiert</td>
					<td width="10" style="background: #DDDDDD"></td><td>demn&auml;chst verf&uuml;gbar</td>
					</tr>
					</table>
					</div>
				</div>
				';
				
				if(strlen($vi->other) > 0){
					print '
					<div class="content" id="otherInfo">
						<div class="caption">Sonstiges</div>
						'.$vi->other.'
					</div>
					';
				}
			}
		}else{
			print '
				<div class="content">
					<div class="caption">Versions-Informationen</div>
					<div>Versions-Informationen sind zur Zeit nicht verf&uuml;gbar</div>
				</div>
				';
		}
	}
	
	print '
		<div class="content">
			<div class="caption">Lizenzbestimmungen</div>
			<div>
			<ul>
			<li><a href="http://www.g5-scripts.de/scripte__newsletter_php__lizenzbedingungen.htm">G5-Scripts.de PHP Newsletter Script</a></li>
			<li><a href="http://tinymce.moxiecode.com/index.php">TinyMCE</a> (HTML-Editor zum Verfassen von HTML Newsletter) - <a href="http://tinymce.moxiecode.com/js/tinymce/jscripts/tiny_mce/license.txt" target="_blank">Lesser General Public License (LGPL)</a></li>
			<li>Icons (<a href="http://www.famfamfam.com" target="_blank">FAMFAMFAM.com</a> SILK ICONS) - <a href="http://creativecommons.org/licenses/by/2.5/" target="_blank">Creative Commons Attribution 2.5 License</a></li>
			<li>Icons (<a href="http://www.fatcow.com/free-icons/" target="_blank">fatcow.com</a> free-icons) - <a href="http://creativecommons.org/licenses/by/3.0/" target="_blank">Creative Commons Attribution 3.0 License</a></li>
			</ul>
			</div>
		</div>
		';
	site_footer();
}

function setup() {
	if(file_exists("variablen.php")){include("variablen.php");} clearstatcache();
	if(empty($script_url)){$script_url=preg_replace("/\/protected\/admin.php/","","http://".$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME']);}
	if(empty($script_pfad)){
		if(isset($_SERVER['PATH_TRANSLATED'])){$script_pfad = $_SERVER['PATH_TRANSLATED'];}
		if(isset($_SERVER['SCRIPT_FILENAME'])){$script_pfad = $_SERVER['SCRIPT_FILENAME'];}
		$script_pfad=preg_replace("/\\\\/","/",$script_pfad);
		$script_pfad=preg_replace("/\/\//","/",$script_pfad);
		$script_pfad=preg_replace("/\/protected\/admin.php/","",$script_pfad);
	}
	

	$sel['flock'] = isset($flock) && $flock == 1 ? "checked" : "";
	$sel['adminNotifyAtSignin'] = isset($adminNotifyAtSignin) && $adminNotifyAtSignin == 1 ? "checked" : "";
	$sel['adminNotifyAtSignout'] = isset($adminNotifyAtSignout) && $adminNotifyAtSignout == 1 ? "checked" : "";
	$sel['formCss'] = isset($formCss) && $formCss == 1 ? "checked" : "";
	$sel['catHide'] = isset($catHide) && $catHide == 1 ? "checked" : "";

	if(!isset($sender)){$sender='';}
	if(!isset($sender_name)){$sender_name='';}
	if(!isset($ruecklaufer)){$ruecklaufer='';}
	if(!isset($redirect_anm1)){$redirect_anm1='';}
	if(!isset($redirect_anm2)){$redirect_anm2='';}
	if(!isset($redirect_abm1)){$redirect_abm1='';}
	if(!isset($redirect_abm2)){$redirect_abm2='';}
	if(!isset($redirect_anm3)){$redirect_anm3='';}
	if(!isset($redirect_abm3)){$redirect_abm3='';}
	
	if(!isset($formTxt1)) $formTxt1 = "Ihre E-Mail Adresse:";
	if(!isset($formTxt2)) $formTxt2 = "welche News m&ouml;chten Sie erhalten?";
	if(!isset($formTxt3)) $formTxt3 = "Eintragen";
	if(!isset($formTxt4)) $formTxt4 = "Austragen";
	if(!isset($formTxt5)) $formTxt5 = "Senden";
	if(!isset($formTxt11)) $formTxt11 ="Vielen Dank f&uuml;r Ihre Anmeldung!<br>Sie erhalten in wenigen Sekunden eine E-Mail in der Sie einen Link finden,<br>bitte klicken Sie auf den Link um Ihre Anmeldung zu best&auml;tigen!";
	if(!isset($formTxt12)) $formTxt12 ="Vielen Dank f&uuml;r Ihre Anmeldung!<br>Sie sind nun in unserem Newsletter System eingetragen!";
	if(!isset($formTxt13)) $formTxt13 ="Ihre E-Mail Adresse ist bereits in unserem Newsletter System eingetragen!";
	if(!isset($formTxt14)) $formTxt14 ="Wir bedauern Ihre Abmeldung sehr.<br>Sie erhalten in wenigen Sekunden eine E-Mail in der Sie einen Link finden,<br>bitte klicken Sie auf den Link um Ihre Abmeldung zu best&auml;tigen!";
	if(!isset($formTxt15)) $formTxt15 ="Sie sind nun aus unserem Newsletter System ausgetragen!";
	if(!isset($formTxt16)) $formTxt16 ="Sie sind bereits aus unserem Newsletter System ausgetragen!";
	if(!isset($formTxt17)) $formTxt17 ="Bitte geben Sie eine g&uuml;ltige E-Mail Adresse ein!";
	if(!isset($formTxt18)) $formTxt18 ="Bitte w&auml;hlen Sie eine Kategorie aus!";
	
    if(!isset($formTxtHdr)) $formTxtHdr ="<div style=\"color:red\">";
    if(!isset($formTxtFtr)) $formTxtFtr ="</div>";    
    
	if(!isset($catView)){$catView='selectbox';}
	$sel['selectbox'] = $sel['checkbox'] = $sel['radiobox'] = $sel['multiselectbox'] = '';
	$sel[$catView] = "checked";
	
	if(!isset($mailformat)){$mailformat='text';}
	$sel['text'] = $sel['html'] = '';
	$sel[$mailformat] = "checked";
	
	
	if(!isset($mail_header)){
		$mail_header  ="Bsp.: Sie bekommen diese Mail, weil Sie sich vor einiger Zeit\n";
		$mail_header .="für unser Newsletter angemeldet haben.\n";
		$mail_header .="--------------------------------------------------------------------------\n";
	}

	if(!isset($mail_footer)){
		$mail_footer  ="\n\nMit freundlichen Grüßen\n";
		$mail_footer .="Ihr ????? Team\n";
	}
	
	$sel['hfOutputArchveIntern'] = isset($hfOutputArchveIntern) && $hfOutputArchveIntern == 1 ? "checked" : "";
	$sel['hfOutputArchvePublic'] = isset($hfOutputArchvePublic) && $hfOutputArchvePublic == 1 ? "checked" : "";
	$sel['hfAlwaysUpToDate']	 = isset($hfAlwaysUpToDate) && $hfAlwaysUpToDate == 1 ? "checked" : "";
	
	site_header("Script Optionen/Einstellungen", "Setup16");
	print '
		<form name="form1" method="post" action="admin.php">
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
		<tr><td colspan=2 class="caption">Script URL und Pfad</td></tr>
        <tr><td width="40%"><input type="text" name="script_url" size="40" value="'.$script_url.'"></td><td width="60%">URL zum Scriptverzeichnis<br>(Bsp.: '.$script_url.')</td></tr>
        <tr><td><input type="text" name="script_pfad" size="40" value="'.$script_pfad.'"></td><td>Pfad zum Scriptverzeichnis<br>(Bsp.: $script_pfad)</td></tr>
        <tr><td><input type="checkbox" name="flock" value="1" '.$sel['flock'].'> Flock </td><td>Aktivieren Sie bitte das K&auml;stchen, wenn es sich bei diesem Server um einen Unix/Linux Server handelt</td></tr>
        </table>
		</div>
		
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
		<tr><td colspan=2 class="caption">Newsletter Absender Name und E-Mail Adresse</td></tr>
        <tr><td width="40%"><input type="text" name="sender" size="40" value="'.$sender.'"></td><td>Admin-E-Mail-Adresse, die als Absender genommen wird.</td></tr>
        <tr><td><input type="text" name="sender_name" size="40" value="'.$sender_name.'"></td><td>Name des Absenders (z.B. G5-Scripts.de Newsletter)</td></tr>
		<tr><td><input type="text" name="ruecklaufer" size="40" value="'.$ruecklaufer.'"></td><td>E-Mail-Adresse f&uuml;r R&uuml;ckl&auml;ufer-E-Mails. E-Mails an ung&uuml;ltige E-Mail-Adresse kommen an diese Adresse zur&uuml;ck.<br><span class="red">Hinweis: </span> Diese Funktion wirkt sich <u>nicht auf jedem Server</u> korrekt aus!</td></tr>
        </table>
		</div>
		
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
		<tr><td colspan=2 class="caption">Newsletter Mail Format</td></tr>
		<tr><td width="40%"><input type="radio" name="mailformat" value="text" '.$sel['text'].'> Textmail oder <input type="radio" name="mailformat" value="html" '.$sel['html'].'> HTML-Mail</td><td>Sollen die E-Mail als Text- oder HTML-E-Mails versendet werden?<br>Bei HTML-E-Mails ist zu beachten, dass nun HTML-Tags verwendet werden m&uuml;ssen, bspw. f&uuml;r den Zeilenumbruch ein &lt;br&gt;, f&uuml;r ein Leerzeichen ein &amp;nbsp; usw. <br><span class="red">Hinweis: </span> diese Einstellung gilt nicht f&uuml;r den Abonnenten An- u. Abmeldeverkehr.</td></tr>
		</table>
		</div>
		
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
		<tr><td colspan=2 class="caption">Admin Benachrichtigungen</td></tr>
        <tr><td width="40%"><input type="checkbox" name="adminNotifyAtSignin" value="1" '.$sel['adminNotifyAtSignin'].'> Info an Admin bei Anmeldung</td><td>Aktivieren Sie dieses K&auml;stchen, wenn Sie eine Info-Mail nach Anmeldung eines neuen Abonnenten erhalten m&ouml;chten</td></tr>
		<tr><td><input type="checkbox" name="adminNotifyAtSignout" value="1" '.$sel['adminNotifyAtSignout'].'> Info an Admin bei Abmeldung</td><td>Aktivieren Sie dieses K&auml;stchen, wenn Sie eine Info-Mail nach Abmeldung eines neuen Abonnenten erhalten m&ouml;chten</td></tr>
		</table>
		</div>
		
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
		<tr><td colspan=2 class="caption">Einstellungen f&uuml;r das An- / Abmeldeformular</td></tr>		
		<tr><td><input type="text" name="formTxt1" size="40" value="'.htmlspecialchars($formTxt1, ENT_QUOTES).'"></td><td>Text &uuml;ber dem Feld f&uuml;r die E-Mail Adresse</td></tr>
		<tr><td><input type="text" name="formTxt2" size="40" value="'.htmlspecialchars($formTxt2, ENT_QUOTES).'"></td><td>Text &uuml;ber der Kategorieauswahl</td></tr>
		<tr><td><input type="text" name="formTxt3" size="40" value="'.htmlspecialchars($formTxt3, ENT_QUOTES).'"></td><td>Text f&uuml;r den Radio Button &quot;Eintragen&quot;</td></tr>
		<tr><td><input type="text" name="formTxt4" size="40" value="'.htmlspecialchars($formTxt4, ENT_QUOTES).'"></td><td>Text f&uuml;r den Radio Button &quot;Austragen&quot;</td></tr>
		<tr><td><input type="text" name="formTxt5" size="40" value="'.htmlspecialchars($formTxt5, ENT_QUOTES).'"></td><td>Text f&uuml;r die Schaltfl&auml;che &quot;Senden&quot;</td></tr>
		<tr><td colspan=2>&nbsp;</td></tr>
		<tr><td width="40%">
		<input type="radio" name="catView" value="selectbox" '.$sel['selectbox'].'/> Einfache Select-Box (Einfachauswahl)<br>
		<input type="radio" name="catView" value="radiobox" '.$sel['radiobox'].'/> Radio Buttons (Einfachauswahl)<br>
		<input type="radio" name="catView" value="checkbox" '.$sel['checkbox'].'/> Checkbox Buttons (Mehrfachauswahl)<br>
		<input type="radio" name="catView" value="multiselectbox" '.$sel['multiselectbox'].'/> Multiple Select-Box (Mehrfachauswahl)<br>
		</td><td>
			Diese Einstellung bestimmt das Erscheinungsbild der Kategorieauswahl im An- / Abmeldeformular<br>
			<span class="small">Einfachauswahl bedeutet, dass der User pro An- /Abmeldung nur eine Kategorie ausw&auml;hlen kann.</span><br>
			<span class="small">Mehrfachauswahl bedeutet, dass der User pro An- /Abmeldung mehrere Kategorien ausw&auml;hlen kann, d.h. der er kann sich mit einer Anmeldung gleich in mehrere Kategorien eintragen.</span>
		</td></tr>
		<tr><td colspan=2>&nbsp;</td></tr>
		<tr><td><input type="checkbox" name="catHide" value="1" '.$sel['catHide'].'> Auswahl bei nur einer Kategorie ausblenden</td>
		<td>Aktivieren Sie dieses K&auml;stchen, wenn die Kategorieauswahl bei nur einer Kategorie im System ausgeblendet werden soll</td>
		</tr>
		<tr><td colspan=2>&nbsp;</td></tr>
		<tr><td><input type="checkbox" name="formCss" value="1" '.$sel['formCss'].'> Standard CSS deaktivierten</td>
		<td>
			Das Layout des An- / Abmeldeformulars kann durch CSS bestimmt werden. Das Formular besteht aus 6 Tebellenzeilen, diese haben haben jeweils eine eigene ID mit den Bezeichnungen von &quot;G5NSLFormR<span class="red">1</span>&quot; bis &quot;G5NSLFormR<span class="red">6</span>&quot;.
			D.h. Sie k&ouml;nnen das Aussehen des Formulars durch Ihre eigenen CSS Definitonen bestimmen. Wenn Sie dies tun m&ouml;chten, dann k&ouml;nnen Sie die &quot;Standard CSS&quot;, die von G5-Scripts.de f&uuml;r den Auslieferungszustand gesetzt wurden, hier deaktivierten.
		</td></tr>
		</table>
		</div>
		
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
		<tr><td colspan=2 class="caption">Statustexte / Meldungen w&auml;hrend des An- / Abmeldeprozesses</td></tr>		
		<tr><td width="40%"><textarea name="formTxt11" rows="3" cols="100">'.htmlspecialchars($formTxt11, ENT_QUOTES).'</textarea></td><td>Erster Best&auml;tigungstext nach <b>An</b>meldung, mit dem Hinweis auf eine Best&auml;tigungsmail mit einem Best&auml;tigungslink</td></tr>
		<tr><td width="40%"><textarea name="formTxt12" rows="3" cols="100">'.htmlspecialchars($formTxt12, ENT_QUOTES).'</textarea></td><td>Zweiter Best&auml;tigungstext nach entg&uuml;ltiger <b>An</b>meldung (nach dem Klick auf den Best&auml;tigungslink in der <u>Aktivierungsmail</u>)</td></tr>
		<tr><td width="40%"><textarea name="formTxt13" rows="3" cols="100">'.htmlspecialchars($formTxt13, ENT_QUOTES).'</textarea></td><td>Text mit dem Hinweis auf eine bereits existierende E-Mail Adresse</td></tr>
		<tr><td width="40%"><textarea name="formTxt14" rows="3" cols="100">'.htmlspecialchars($formTxt14, ENT_QUOTES).'</textarea></td><td>Erster Best&auml;tigungstext nach <b>Ab</b>meldung, mit dem Hinweis auf eine Best&auml;tigungsmail mit einem Best&auml;tigungslink</td></tr>
		<tr><td width="40%"><textarea name="formTxt15" rows="3" cols="100">'.htmlspecialchars($formTxt15, ENT_QUOTES).'</textarea></td><td>Zweiter Best&auml;tigungstext nach entg&uuml;ltiger <b>Ab</b>meldung (nach dem Klick auf den Best&auml;tigungslink in der <u>Aktivierungsmail</u>)</td></tr>
		<tr><td width="40%"><textarea name="formTxt16" rows="3" cols="100">'.htmlspecialchars($formTxt16, ENT_QUOTES).'</textarea></td><td>Text mit dem Hinweis auf eine bereits abgemeldete E-Mail Adresse</td></tr>
		<tr><td width="40%"><textarea name="formTxt17" rows="3" cols="100">'.htmlspecialchars($formTxt17, ENT_QUOTES).'</textarea></td><td>Text mit dem Hinweis auf eine ung&uuml;ltige E-Mail Adresse ein (bei An- sowie Abmeldung)</td></tr>
		<tr><td width="40%"><textarea name="formTxt18" rows="3" cols="100">'.htmlspecialchars($formTxt18, ENT_QUOTES).'</textarea></td><td>Text mit dem Hinweis auf eine fehlende Kategorieauswahl (bei An- sowie Abmeldung)</td></tr>
        
        <tr><td colspan=2 class="caption">Header und Footer f&uuml;r <u>alle</u> Statustexte / Meldungen w&auml;hrend des An- / Abmeldeprozesses  (optional)</td></tr>
        <tr><td width="40%"><textarea name="formTxtHdr" rows="3" cols="100">'.htmlspecialchars($formTxtHdr, ENT_QUOTES).'</textarea></td><td>Header f&uuml;r alle Statusmeldungen</td></tr>
        <tr><td width="40%"><textarea name="formTxtFtr" rows="3" cols="100">'.htmlspecialchars($formTxtFtr, ENT_QUOTES).'</textarea></td><td>Footer f&uuml;r alle Statusmeldungen</td></tr>
        
		</table>
		</div>
		
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
		<tr><td colspan=2 class="caption">Weiterleitungen beim An- / Abmeldeprozess (alternativ zu den Statustexten w&auml;hrend des An- / Abmeldeprozesses)</td></tr>
        <tr><td colspan=2>An welche URL soll der User ...</td></tr>
        <tr><td width="40%"><input type="text" name="redirect_anm1" size="40" value="'.$redirect_anm1.'"></td><td>... nach der <u>An</u>meldung weitergeleitet werden? Zum Beispiel auf eine Statusseite, wo der User &uuml;ber den weiteren Verlauf informiert wird.</td></tr>
        <tr><td><input type="text" name="redirect_anm2" size="40" value="'.$redirect_anm2.'"></td><td>... nach dem Klick auf den Best&auml;tigungslink in der <u>Aktivierungsmail</u> weitergeleitet werden?</td></tr>
        <tr><td colspan=2>&nbsp;</td></tr>
        <tr><td colspan=2>An welche URL soll der Abonnent ...</td></tr>
        <tr><td><input type="text" name="redirect_abm1" size="40" value="'.$redirect_abm1.'"></td><td>... nach der <u>Ab</u>meldung weitergeleitet werden? Zum Beispiel auf eine Statusseite, wo der Abonnent &uuml;ber den weiteren Verlauf informiert wird!</td></tr>
        <tr><td><input type="text" name="redirect_abm2" size="40" value="'.$redirect_abm2.'"></td><td>... nach dem Klick auf den Best&auml;tigungslink in der <u>Abmeldungsmail</u> weitergeleitet werden?</td></tr>
        <tr><td colspan=2>&nbsp;</td></tr>
        <tr><td colspan=2>An diese URL wird der Abonnent umgeleitet, wenn seine E-Mail-Adresse im System...</td></tr>
        <tr><td><input type="text" name="redirect_anm3" size="40" value="'.$redirect_anm3.'"></td><td>... <u>bereits vorhanden</u> ist!</td></tr>
        <tr><td><input type="text" name="redirect_abm3" size="40" value="'.$redirect_abm3.'"></td><td>... <u>nicht mehr vorhanden</u> ist!</td></tr>
        </table>
		</div>
		
		<div class="content">
		<table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
        <tr><td class="caption">Newsletter Header/Footer, wird in jedes Newsletter <b>oben/unten</b> automatisch eingef&uuml;gt (optional)</td></tr>
        <tr><td>Header, <b>oben</b> (optional):<br><textarea name="mail_header" rows="3" cols="100">'.htmlspecialchars($mail_header, ENT_QUOTES).'</textarea></td></tr>
        <tr><td>Footer, <b>unten</b> (optional):<br><textarea name="mail_footer" rows="3" cols="100">'.htmlspecialchars($mail_footer, ENT_QUOTES).'</textarea></td></tr>
		<tr><td>
			Der folgende Platzhalter kann innerhalb des Headers, des Footers oder direkt in der Newsletter eingesetzt werden: <font color="#0000FF">&lt;!--abmeldelink--&gt;</font><br>
			Dieser Platzhalter wird in eine URL umgewandelt (bspw.: <font color="#0000FF">http://www.ihredomain.de/newsletter/newsletter.php?ac=austragen.....</font>),<br>
			die der Abonnent aufrufen kann, um sich automatisch aus dem Newsletter abzumelden.<br>
			Bitte beachten Sie, dass der Abonnent nach dem Aufruf dieser URL eine zus&auml;tzliche E-Mail mit einem Best&auml;tigungslink zur Abmeldung erh&auml;lt!<br>
			Beim <font color="#0000FF">Mailformat HTML</font> muss der Platzhalter in einen Link-Tag eingesetzt werden, bspw.: <font color="#0000FF">&lt;a href="&lt;!--abmeldelink--&gt;"&gt;Aus Verteiler abmelden&lt;/a&gt;</font>
		</td></tr>
		<tr><td><input type="checkbox" name="hfOutputArchveIntern" value="1" '.$sel['hfOutputArchveIntern'].'> Den Header und Footer beim Anschauen des Newsletters im <u>internen</u> Archiv ausgeben (Archiv des Admin Bereiches)</td></tr>
		<tr><td><input type="checkbox" name="hfOutputArchvePublic" value="1" '.$sel['hfOutputArchvePublic'].'> Den Header und Footer beim Anschauen des Newsletters im <u>&ouml;ffentlichen</u> Archiv ausgeben (Erweiterung NSLArchive)</td></tr>
        <tr><td><input type="checkbox" name="hfAlwaysUpToDate" value="1" '.$sel['hfAlwaysUpToDate'].'> <b>Immer</b> den  tagesaktuellen Header und Footer ausgeben, statt dem zum Zeitpunk des Versands definierten.<br></td></tr>
        <tr><td colspan="2"></td></tr>
        </table>
		</div>
		<input type="hidden" name="ac" value="store_vars"><input type="submit" name="btn" value="Einstellungen speichern">
        </form>
    ';
	site_footer();
}

function kategorien($in){
	global $script_pfad, $cat, $catVisibility;
	
	if(!isset($catVisibility) || !is_array($catVisibility)) $catVisibility = array();
	$visibilityTT = '';
	$visibilityClass='';
	$visibility = '';
	
	site_header("Kategorien editieren", "CAT16");
	print '
        <div class="content">
        Sie k&ouml;nnen hier verschiedene Newsletter Kategorien anlegen.
        User, die sich anmelden, k&ouml;nnen eine bestimmte Kategorie ausw&auml;hlen, f&uuml;r die sie sich interessieren.
        Sie k&ouml;nnen Ihr Newsletter an alle Kategorien gesondert senden, so dass User,
        die sich bspw. nur f&uuml;r &quot;allgemeine News&quot; interessieren, auch nur &uuml;ber allgemeine News benachrichtigt werden.<br>
        <span class="red">Hinweis:</span> es muss immer mindestens eine Kategorie im System vorhanden sein.<br><br>
		<span class="cat_visibility_public" style="display: block; width: 20px; float:left; text-align:center;">P</span> - &ouml;ffentliche Kategorien (f&uuml;r alle Besucher und Abonnenten zug&auml;nglich)<br>
		<span class="cat_visibility_intern" style="display: block; width: 20px; float:left; text-align:center; ">I</span> - interne Kategorien (nur f&uuml;r Interne Zwecke, z.B. Tests oder interne Empf&auml;ngerlisten)
		</div>
        <br>
		<div class="content">
        <table class="catList" border="0" cellspacing="0" cellpadding="2" style="width: 100%">
        <tr class="caption">
			<td >Kategoriename oder ID (interner Name)</td>
			<td >Kategoriebezeichnung (&ouml;ffentlicher Name)</td>
			<td align="center">Anzahl Abonnenten</td>
			<td width="15">&nbsp;</td>
			<td width="15">&nbsp;</td>
			<td width="40">&nbsp;</td>
		</tr>
    ';
	
	for($x=0;$x < sizeof($cat);$x++) {
		$catID = key($cat);
		$zeilen = array();
		if(file_exists("$script_pfad/protected/abonnenten/".$catID.".txt")){
			$zeilen = file("$script_pfad/protected/abonnenten/".$catID.".txt");
		}
		
		if(!isset($catVisibility[$catID])) $catVisibility[$catID]='public';
		if($catVisibility[$catID] == 'public') {$visibility = 'P';$visibilityClass = 'public';$visibilityTT='&ouml;ffentliche Kategorie';}
		if($catVisibility[$catID] == 'intern') {$visibility = 'I';$visibilityClass = 'intern';$visibilityTT='interne Kategorie';}
		
		print '<tr class="catRow">
				<td>&nbsp;'.$catID.'</td>
				<td>&nbsp;'.$cat[$catID].'</td>
				<td align="center">'.count($zeilen).'</td>
				<td align="center" class="cat_visibility_'.$visibilityClass.'" title="'.$visibilityTT.'">'.$visibility.'</td>
				<td align="center">&nbsp;</td>
				<td>
					<a href="admin.php?ac='.$in['ac'].'&chcat='.$catID.'" title="&auml;ndern"><img src="style/application_form_edit.png" border="0"></a>
					<a href="admin.php?ac=dele_cat&cat='.$catID.'" title="l&ouml;schen" onClick="return confirm(\'Kategorie '.$cat[$catID].' wirklich l&ouml;schen?\')"><img src="style/delete.png" border="0"></a>
				</td>
			   </tr>';
		next($cat);
	}
	
	print '
        </table>
		</div>
        <br>
    ';
	
	if(isset($in['chcat'])){
		if($in['chcat'] != ''){
			if(!isset($catVisibility[$in['chcat']])) $catVisibility[$in['chcat']]='public';
			$sel['public'] = '';
			$sel['intern'] = '';
			$sel[$catVisibility[$in['chcat']]]='checked';
			print '
				<center>
				<div class="content" style="width: 400px;">
                <table class="catForm" border="0" cellspacing="0" cellpadding="2" style="width: 100%">
                <form name="catForm" method="post" action="admin.php">
                <tr class="caption"><td colspan="2" align="center">Bezeichnung der Kategorie &auml;ndern</td></tr>
                <tr><td align="center"><input type="text" name="catName" value="'.htmlspecialchars($in['chcat'], ENT_QUOTES).'" readonly style="background: #EEEEEE;"></td><td nowrap>Kategoriename<br><span class="small">(nicht &auml;nderbar)</span></td></tr>
                <tr><td align="center"><input type="text" name="catCaption" value="'.htmlspecialchars($cat[$in['chcat']], ENT_QUOTES).'"></td><td nowrap>Kategorietitel<br><span class="small">(Sichtbarer Name, z.B. Allgemeine News)</span></td> </tr>
                <tr><td colspan="2">
					<input type="radio" name="catVisibility" value="public" '.$sel['public'].'/>&nbsp;&ouml;ffentlich&nbsp;&nbsp;
					<input type="radio" name="catVisibility" value="intern" '.$sel['intern'].'/>intern (nur f&uuml;r admin sichtbar)
				</td></tr>
                <tr><td colspan="2"><input type="hidden" name="ac" value="ch_cat"><input type="submit" name="btn" value="speichern"></td></tr>
                </form>
                </table>
				</div>
				</center>
                <br>
            ';
		}
	}else{
		print '
			<center>
			<div class="content" style="width: 400px;">
            <table class="catForm" border="0" cellspacing="0" cellpadding="2" style="width: 100%">
            <form name="catForm" method="post" action="admin.php">
            <tr class="caption"><td colspan="2" align="center">Neue Kategorie anlegen</td></tr>
            <tr><td align="center"><input type="text" name="catName"></td><td nowrap>Kategoriename<br>(<span class="red small">! keine !</span> <span class="small">Sonderzeichen, z.B. allg_news)</span></td></tr>
            <tr><td align="center"><input type="text" name="catCaption"></td><td nowrap>Kategorietitel<br><span class="small">(Sichtbarer Name, z.B. Allgemeine News)</span></td></tr>
            <tr><td colspan="2">
				<input type="radio" name="catVisibility" value="public" checked/>&nbsp;&ouml;ffentlich&nbsp;&nbsp;
				<input type="radio" name="catVisibility" value="intern"/>intern (nur f&uuml;r admin sichtbar)
			</td></tr>
			<tr><td colspan="2"><input type="hidden" name="ac" value="new_cat"><input type="submit" name="btn" value="speichern"></td></tr>
            </form>
            </table>
			</div>
			</center>
            <br>
        ';
	}
	site_footer();
}

function email_templ($in){
	global $script_pfad, $ISDEMO;
	if(file_exists("$script_pfad/protected/data/betreffs.php")){
		include($script_pfad."/protected/data/betreffs.php");
	}
	if(!isset($in['template']))    {$in['template']="";}
	if($in['template'] == "")      {$in["template"] = "anmeldebestaetigung";}
	$sel["anmeldebestaetigung"] = ($in['template'] == "anmeldebestaetigung") ? "selected" : "";
	$sel["angemeldet"]          = ($in['template'] == "angemeldet") ? "selected" : "";
	$sel["abmeldebestaetigung"] = ($in['template'] == "abmeldebestaetigung") ? "selected" : "";
	$sel["abgemeldet"]          = ($in['template'] == "abgemeldet") ? "selected" : "";
	$sel["admAngemeldet"]		= ($in['template'] == "admAngemeldet") ? "selected" : "";
	$sel["admAbgemeldet"]       = ($in['template'] == "admAbgemeldet") ? "selected" : "";
	
	/* nur aus kompatibilit&auml;tsgr&uuml;nden zu &auml;lteren versionen, dort vertippt bei 'anmeledebestaetigung' */
	if(file_exists("$script_pfad/protected/data/anmeledebestaetigung.txt")){	
		//verschrieben in einer &auml;lteren version.
		$mailtext = saGetFileContent("$script_pfad/protected/data/anmeledebestaetigung.txt");
		$mailtext = join("", $mailtext);
		store("$script_pfad/protected/data/anmeldebestaetigung.txt", $mailtext);
		fileDelete("$script_pfad/protected/data/anmeledebestaetigung.txt");
	}

	if($in["template"] == "anmeldebestaetigung" && !isset($betreff["anmeldebestaetigung"])){
		$betreff["anmeldebestaetigung"] = $betreff["anmeledebestaetigung"];
	}
	/* ENDE */

	if(!$ISDEMO){
		if (isset($in["action"])){
			if($in["action"] == "store"){
				$in["mailtext"] = get_magic_quotes_gpc() ? stripslashes($in["mailtext"]) : $in["mailtext"];
				$betreff[$in["template"]] = get_magic_quotes_gpc() ? stripslashes($in["betreff"]) : $in["betreff"];
				
				$var  = "<?php\n" ;
				for($x=0;$x<sizeof($betreff);$x++) {
                    $key = key($betreff);
                    $val = current($betreff);
                    
                    $val = get_magic_quotes_gpc() ? stripslashes($val) : $val;
                    $val = str_replace('\\', '\\\\', $val);
                    $val = str_replace('"', '\\"', $val);
                    
					$var .= "\$betreff['".$key."'] = \"".$val."\";\n";
					next($betreff);
				}
				$var .= "?>\n";
				
				store("$script_pfad/protected/data/betreffs.php",$var);
				store("$script_pfad/protected/data/".$in["template"].".txt",$in['mailtext']);
			}
		}
	}

	$titel = array(
		'anmeldebestaetigung'  => 'Anmeldebest&auml;tigung+Best&auml;tigungslink',
		'angemeldet'           => 'Anmeldung best&auml;tigt (angemeldet)',
		'abmeldebestaetigung'  => 'Abmeldebest&auml;tigung+Best&auml;tigungslink',
		'abgemeldet'           => 'Abmeldung best&auml;tigt (abgemeldet)',
		'admAngemeldet'        => 'Admin Info: neuer Abonnent angemeldet',
		'admAbgemeldet'        => 'Admin Info: Abonnent abgemeldet'
		);

	$mailtext = saGetFileContent("$script_pfad/protected/data/".$in['template'].".txt");
	
	switch($in['template']){
		case 'anmeldebestaetigung':
		case 'abmeldebestaetigung':
			$infoText='Der folgende Platzhalter muss in den An- und Abmeldemails verwendet werden: <font color="#0000FF">&lt;!--bestaetigungslink--&gt;</font><br>Dieser Platzhalter wird in einen Link umgewandelt, auf den der Abonnent klicken muss, um seine An- oder Abmeldung zu best&auml;tigen.';
			break;
		case 'admAngemeldet':
		case 'admAbgemeldet':
			$infoText='Der folgenden Platzhalter k&ouml;nnen in diesem Template verwendet werden:<br>
						<font color="#0000FF">&lt;!--email--&gt;</font> - dieser Platzhalter wird in die E-Mail Adresse des Abonnenten umgewandelt<br>
						<font color="#0000FF">&lt;!--cat--&gt;</font> - dieser Platzhalter wird in den Kategorie Namen umgewandelt';
			break;
		default:
			$infoText='';
			break;			
	}	
	
	site_header("Templates f&uuml;r An- und Abmelde E-Mails", "VAR16");
	print '
		<div class="content">
        Hier finden Sie die E-Mail Templates f&uuml;r den An- und Abmeldeverkehr, die
        an Ihre Abonnenten geschickt werden, sobald sich diese f&uuml;r Ihr Newsletter
        an- bzw. abmelden. Wenn sich ein Abonnent an- oder abmeldet, bekommt er zun&auml;chst
        eine E-Mail in der sich ein Link befindet, auf diesen Link muss der Abonnent klicken
        um seine An- oder Abmeldung zu best&auml;tigen.<br>
        Nach der Best&auml;tigung der An- oder Abmeldung erh&auml;lt der Abonnent eine
        2te An- oder Abmeldemail, wo ihm nun entg&uuml;ltig best&auml;tigt wird, dass
        er im System eingetragen bzw. aus dem System ausgetragen wurde. <br>
        <span class="red">Hinweis:</span> Die E-Mails werden ausschlie&szlig;lich
        im Format &quot;<b>text</b>&quot;, ohne Header und Footer versendet.
		</div>
        <br>
		<div class="content">
        <table cellspacing="0" cellpadding="2" border="0" style="width: 100%">
        <tr><td>
        <table width="100%" border="0" cellspacing="0" cellpadding="0" >
        <tr class="caption"><td width="50%">&nbsp;'.$titel[$in['template']].'</td>
		<form name="form" method="post" action="admin.php"><td width="50%" align="right" nowrap>
        <select name="template">
		';
	for($x=0;$x<sizeof($titel);$x++) {
		print '<option value="'.key($titel).'" '.$sel[key($titel)].'>'.current($titel).'</option>';
		next($titel);
	}
	print '
        </select>
        <input type="hidden" name="ac" value="email_templ">
        <input type="submit" name="Abschicken" value="GO" style="width: 30px;">
        </td></form></tr>
        </table>
        </td></tr>
        <form name="form1" method="post" action="admin.php">
        <tr><td>Betreff:<br><input type="text" name="betreff" size="125" value="'.htmlspecialchars($betreff[$in['template']], ENT_QUOTES).'" style="width: 100%;"></td></tr>
        <tr><td>E-Mail Inhalt:<br><textarea name="mailtext" cols="122" rows="20">'.htmlspecialchars(join("", $mailtext), ENT_QUOTES).'</textarea></td></tr>
        <tr><td><font size="1" face="Arial, Helvetica, sans-serif">'.$infoText.'</font><br>
        <input type="hidden" name="ac" value="email_templ">
        <input type="hidden" name="action" value="store">
        <input type="hidden" name="template" value="'.$in['template'].'">
        <input type="submit" name="btn" value="Template speichern">
        </td></tr></form></table>
		</div>
    ';
	site_footer();
}

function letterarchiv(){
	global $script_pfad, $cat, $catVisibility;

	if(!isset($catVisibility) || !is_array($catVisibility)) $catVisibility = array();
	$visibilityTT = '';
	$visibilityClass='';
	$visibility = '';
	
	site_header("Archiv der bereits versendeten Newsletter", "Report16");

	for($x=0; $x < sizeof($cat);$x++) {
		$catID = key($cat);
		if(!isset($catVisibility[$catID])) $catVisibility[$catID]='public';
		if($catVisibility[$catID] == 'public') {$visibility = 'P';$visibilityClass = 'public';$visibilityTT='&ouml;ffentliche Kategorie';}
		if($catVisibility[$catID] == 'intern') {$visibility = 'I';$visibilityClass = 'intern';$visibilityTT='interne Kategorie';}

		print '
            <div class="content">
            <table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
            <tr class="caption" align="center">
				<td colspan=3>Kategorie: '.$cat[$catID].'</td>
				<td align="center" width="15" class="cat_visibility_'.$visibilityClass.'" title="'.$visibilityTT.'">'.$visibility.'</td>
			</tr>
            <tr class="caption2" align="center">
				<td width="65%">Titel / Betreff</td>
				<td width="25%">versendet am</td>
				<td>&nbsp;</td>
				<td>&nbsp;</td>
			</tr>
        ';
		$letters = saGetFileContent("$script_pfad/protected/letters/".$catID.".idx");
		if(count($letters)>0){
			foreach($letters as $line){
				if(strlen(trim($line)) > 0){
					list($time,$betreff)=explode("|", $line);
					print '<tr>
					<td><a href="admin.php?ac=show_letter&id='.$time.'">'.$betreff.'</a></td>
					<td align="center">'.date("d-m-Y - H:i",$time).'</td>
					<td align="center" colspan="2">
						<a href="admin.php?ac=show_letter&id='.$time.'"><img src="style/report_edit.png" border="0" title="lesen"></a>
						<a href="admin.php?ac=dele_letter&id='.$time.'" onClick="return confirm(\'Newsletter wirklick l&ouml;schen?\')"><img src="style/delete.png" border="0" title="l&ouml;schen"></a>
					</td>
					</tr>';
				}
				
			}
		}else{
			print '<tr>
					<td colspan="4" style="text-align: center; font-style: italic;">-- noch keine Newsletter an diese Kategorie versendet --</td>
				   </tr>';
		}
		print '</table>
				</div>
				<br>
				';
		next($cat);
	}
	print '<br>';
	site_footer();
}

function show_letter($in){
	global $script_pfad, $cat, $mail_header, $mail_footer, $hfOutputArchveIntern, $hfAlwaysUpToDate;
	
	$letter = new NSLetter("$script_pfad/protected/letters/", $in['id']);
	$letter->Load();
	
	/*
	//$id     =preg_replace("/(\015\012)+|(\015)+|(\012)+/i","",$letter[0]);
	$cat_arr=preg_replace("/(\015\012)+|(\015)+|(\012)+/i","",$letter[1]);
	$format =preg_replace("/(\015\012)+|(\015)+|(\012)+/i","",$letter[2]);
	$betreff=preg_replace("/(\015\012)+|(\015)+|(\012)+/i","",$letter[3]);
	*/
	
	$categorien=array();
	foreach($letter->categorie as $c){
		array_push($categorien, $cat[$c]);
	}
	site_header("Zeige Newsletter mit dem Betreff: ".$letter->subject, "ReportEdit16");

	print '
		<div class="content">
        <table border="0" cellspacing="0" cellpadding="2" style="width: 100%">
        <tr><td>Betreff des Newsletters: '.htmlspecialchars($letter->subject, ENT_QUOTES).'</td></tr>
        <tr><td>Format des Newsletters: '.$letter->format.'</td></tr>
		<tr><td>Kategorie(n): '.join(", ", $categorien).'</td></tr>
        <tr><td>&nbsp;</td></tr>
		<tr class="caption"><td>Inhalt des Newsletters:</td></tr>
        <tr><td>
        ';
	if($letter->IsText()) print "<pre>";

	if($hfOutputArchveIntern == "1"){
		if($hfAlwaysUpToDate == "1"){
			print $mail_header;
		}else{
			print $letter->header;
		}
	}
	
	print $letter->message;
	
	if($hfOutputArchveIntern == "1"){
		if($hfAlwaysUpToDate == "1"){
			print $mail_footer;
		}else{
			print $letter->footer;
		}
	}
	
	if($letter->IsText()) print "</pre>";

	print "</td></tr></table>
			</div>
	";

	site_footer();
	exit;
}

function dele_letter($in){
	global $script_pfad, $ISDEMO;
	
	if(!$ISDEMO){
		$letter = new NSLetter("$script_pfad/protected/letters/", $in['id']);
		$letter->Load();
		
		$id   = $letter->id;
		$cats = $letter->categorie;
		if($id == $in['id']){
			fileDelete("$script_pfad/protected/letters/$id");
			$new_letters=array();
			foreach($cats as $cat_v) {
				if(file_exists("$script_pfad/protected/letters/$cat_v.idx")){$letters = file("$script_pfad/protected/letters/$cat_v.idx");}
				foreach($letters as $zeile){
					list($id2,$betreff,$null)=explode("|", $zeile);
					if($id2 != $id){array_push($new_letters, $zeile);}
				}
				store("$script_pfad/protected/letters/$cat_v.idx",join("",$new_letters));
				unset($new_letters);
				$new_letters=array();
			}
		}
	}
	header("Location: admin.php?ac=letterarchiv");
}

function neue_newsletter($in){
	global $script_pfad, $script_url, $cat, $sender, $sender_name, $mailformat, $mail_header, $mail_footer, $ISDEMO;
	$mail_header = get_magic_quotes_gpc() ? stripslashes($mail_header) : $mail_header;
	$mail_header = get_magic_quotes_gpc() ? stripslashes($mail_header) : $mail_header;
	$time = time();

	
	$header_rows = (strlen($mail_header) > 0) ? count(explode("\n", $mail_header)) : 1;
	$footer_rows = (strlen($mail_footer) > 0) ? count(explode("\n", $mail_footer)) : 1;
	
	site_header("Neuen Newsletter verfassen", "ReportEdit16");
	
	$templateTitle   = "";
	$templateBetreff = "";
	$templateInhalt  = "";
	$templateCats	 = array();
	if(class_exists("NSLTemplate", false)){
		//		print var_dump($in);
		//		exit;
		print NSLTemplate::GetFormularExtensionTop($in);
		
		if(isset($in['templateID'])){
			$e = NSLTemplate::LoadTemplate($in);
			if(is_object($e)){
				$templateTitle = htmlspecialchars($e->title, ENT_QUOTES);
				$templateBetreff = htmlspecialchars($e->subject, ENT_QUOTES);
				$templateInhalt = $e->content;
				$templateInhalt = str_replace('&', '&amp;', $templateInhalt);
				if(isset($e->categories) && strlen($e->categories) > 0){
					$templateCats = explode(',', $e->categories);
					if(!is_array($templateCats))
						$templateCats=array();
				}
			}
		}
	}
	
	$headerFooterInhalt = '';
	if(strlen($mail_header)>0 || strlen($mail_footer)>0)
		$headerFooterInhalt = ' (Header > Inhalt > Footer, Header und Footer sind hier nicht ver&auml;nderbar)';
	
	if ($mailformat == 'html'){
		print '
		<script type="text/javascript">
			// O2k7 skin (silver)
			tinyMCE.init({
				// General options
				language : "de",
				mode : "exact",
				elements : "mailtext",
				theme : "advanced",
				skin : "o2k7",
				skin_variant : "black",
				verify_html : false,
				forced_root_block : "",
				convert_urls : false,
				relative_urls : true,

				plugins : "lists,pagebreak,style,layer,table,save,advhr,advlink,emotions,iespell,insertdatetime,preview,media,searchreplace,print,contextmenu,paste,directionality,fullscreen,noneditable,visualchars,nonbreaking,xhtmlxtras,template,inlinepopups,autosave,advimage,-explorer",

				// Theme options
				theme_advanced_buttons1 : "fullscreen,code,cleanup,help,|,print,preview,|,bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,styleselect,formatselect,fontselect,fontsizeselect",
				theme_advanced_buttons2 : "cut,copy,paste,pastetext,pasteword,|,search,replace,|,bullist,numlist,|,outdent,indent,blockquote,|,undo,redo,|,link,unlink,anchor,charmap,iespell,image,media,advhr,|,insertdate,inserttime,|,forecolor,backcolor",
				theme_advanced_buttons3 : "tablecontrols,|,hr,removeformat,visualaid,|,sub,sup,|,ltr,rtl,|,insertlayer,moveforward,movebackward,absolute,|,styleprops,|,cite,abbr,acronym,del,ins,attribs,|,explorer",
				theme_advanced_toolbar_location : "top",
				theme_advanced_toolbar_align : "left",
				theme_advanced_statusbar_location : "bottom",
				theme_advanced_resizing : true,

				// Example content CSS (should be your site CSS)
				//content_css : "css/content.css",

				// Drop lists for link/image/media/template dialogs
				// template_external_list_url : "lists/template_list.js",
				// external_link_list_url : "lists/link_list.js",
				 external_image_list_url : "imagelist.php",
				// media_external_list_url : "lists/media_list.js",
			});
		</script>
		';
	}
	
	print '
        <div class="content">
        <table cellspacing="0" cellpadding="2" style="width: 100%">
        <tr><td colspan="3" height="1"><strong>Betreff:</strong><br><input type="text" id="betreff" name="betreff" value="'.$templateBetreff.'" size="126" style="width: 100%"></td></tr>
        <tr><td id="inputfields" colspan="3" valign="top"><strong>Newsletter Inhalt</strong>'.$headerFooterInhalt.':<br>
		';
	if(strlen($mail_header)>0){
		print '<textarea name="mail_header" cols="123" rows="'.$header_rows.'" readonly style="background: #EFEFEF; width: 100%" title="Header">'.$mail_header.'</textarea>';
	}
	print '
		<textarea id="mailtext" name="mailtext" cols="123" rows="30" style="width: 100%">'.$templateInhalt.'</textarea>
		';
	if(strlen($mail_footer)>0){
		print '<textarea name="mail_footer" cols="123" rows="'.$footer_rows.'" readonly style="background: #EFEFEF; width: 100%" title="Footer">'.$mail_footer.'</textarea>';
	}
	print '
		</td></tr>
		<tr><td colspan="3">&nbsp;</td></tr>
        <tr><td width="33%" valign="top">
		<div id="nslContainerSendToUser" class="content" style="height: 160px;">
		<div class="caption">Kategorien ausw&auml;hlen</div>
		<div>
		<span class="small">W&auml;hlen Sie die Kategorie(n) aus, <br>an die dieses Newsletter gesendet werden soll</span><br>
        <select id="categorie" name="categorie[]" multiple size="4" style="width: 100%">
    ';
	
	for($x = 0; $x < sizeof($cat); $x++) {
		$key = key($cat);
		$sel = in_array($key, $templateCats) ? "selected" : "";
		print '<option value="'.$key.'" '.$sel.'>'.current($cat).'</option>';
		next($cat);
	}

	print '
        </select>
        <br>
		<span class="red small">Hinweis</span><span class="small">: f&uuml;r Mehrfachauswahl die STRG-Taste halten</span>
		<input type="button" id="sendToUser" name="sendToUser" value="Newsletter an Abonnenten senden">
		</div>
		</div>
		</td>
		<td valign="top" width="33%">
			<div id="nslContainerSendToAdmin" class="content" style="height: 160px;">
			<div class="caption">Test Newsletter an Admin</div>
			<div>
			&Uuml;ber diese Funktion k&ouml;nnen Sie das verfasste Newsletter zum Testzwecke an die E-Mail-Adresse des Admins senden
			
			<input type="button" id="sendToAdmin" name="sendToAdmin" value="Newsletter an Admin senden">
			</div>
			</div>
		</td>
		';
	if(class_exists("NSLTemplate", false)){
		print NSLTemplate::GetFormularExtensionBottom($templateTitle);
	}else{
		print '<td valign="top" width="33%">&nbsp;</td>';
	}
	print '
		</tr>
        </table>
        </div>
    ';
	site_footer();
}

function abonnenten($in){
	global $script_pfad, $cat, $catVisibility, $ISDEMO;

	if(!isset($catVisibility) || !is_array($catVisibility)) $catVisibility = array();
	$visibilityTT = '';
	$visibilityClass='';
	$visibility = '';
	
	if(!$ISDEMO){
		if (isset($in['ch_cat_abon'])){
			if($in['ch_cat_abon'] != ''){
				if(file_exists("$script_pfad/protected/abonnenten/".$in['ch_cat_abon'].".txt")){
					$in['adressen']=preg_replace("/(\015\012)+|(\015)+|(\012)+/i"," ",$in['adressen']);
					$in['adressen']=explode(" ", $in['adressen']);
					
					store("$script_pfad/protected/abonnenten/".$in['ch_cat_abon'].".txt",trim(implode("\n", $in['adressen']))."\n");
				}
			}
		}
	}

	site_header("Newsletter Abonnenten", "Users16");

	print '
        <table border="0" cellspacing="5" cellpadding="5" style="width: 100%">
        <tr>
    ';

	$i2=0;
	for($i=0; $i<count($cat); $i++){
		$catID = key($cat);
		if(!isset($catVisibility[$catID])) $catVisibility[$catID]='public';
		if($catVisibility[$catID] == 'public') {$visibility = 'P';$visibilityClass = 'public';$visibilityTT='&ouml;ffentliche Kategorie';}
		if($catVisibility[$catID] == 'intern') {$visibility = 'I';$visibilityClass = 'intern';$visibilityTT='interne Kategorie';}

		$adressen = saEMailAddress($catID);
		if(count($adressen) > 0){
			if($ISDEMO){
				$tmp = array();
				for($z=0; $z<count($adressen);$z++)
					array_push($tmp, "xx.demo.xx@g5-scripts.de");
				$adressen = $tmp;
			}
		}
		$bearbeiten = '<a href="admin.php?ac='.$in['ac'].'&ed_cat='.$catID.'#cat'.$catID.'">bearbeiten</a>';
		print '
            <td valign="top" width="33%">
			<div class="content" style="width: 100%;">
            <table width="100%" border="0" cellspacing="0" cellpadding="2">
            <tr class="caption">
				<td align="left">'.current($cat).'</td>
				<td align="right">'.count($adressen).'</td>
				<td align="center" width="15" class="cat_visibility_'.$visibilityClass.'" title="'.$visibilityTT.'">'.$visibility.'</td>
			</tr>
            <tr><td align="right" colspan="3">'.$bearbeiten.'</td></tr>
			<tr><td align="left" colspan="3"><div style="height: 150px; border: 1px solid gray; overflow-y: auto;">'.preg_replace("/(\015\012)|(\015)|(\012)/i","",implode("<br>",$adressen)).'</div></td></tr>
            </table>
			</div>
            </td>
        ';
		$i2++;
		if($i2==3){print '</tr><tr>';$i2=0;}

		next($cat);
	}
	if($i2 < 3 && $i2 != 0){for($i=$i2; $i<3; $i++){print '<td width="33%">&nbsp;</td>';}}
	print '
        </tr>
        </table>
		<br>
    ';
	$in['ed_cat'] = (!isset($in['ed_cat'])) ? '' : $in['ed_cat'];
	if($in['ed_cat'] != ''){
		$adressen = saEMailAddress($in['ed_cat']);
		if(count($adressen) > 0){
			if($ISDEMO){
				$tmp = array();
				for($i=0; $i<count($adressen);$i++)
					array_push($tmp, "xx.demo.xx@g5-scripts.de");
				$adressen = $tmp;
			}	
		}

		print '
			<a name="cat'.$in['ed_cat'].'" id="cat'.$in['ed_cat'].'"></a>
			<div class="content" style="width: 350px;">
            <table width="350" border="0" cellspacing="0" cellpadding="2">
            <form name="form1" method="post" action="admin.php">
            <tr bgcolor="#666666"><td align="center"><font color="#CCCCCC">Abonnenten einer Kategorie &auml;ndern</font></td></tr>
            <tr><td>Kategorie: '.$cat[$in['ed_cat']].'</td></tr>
			<tr><td>Abonnenten Anzahl: '.count($adressen).'</td></tr>
            <tr><td>E-Mail-Adressen der Abonnenten:<br>
            <textarea name="adressen" cols="60" rows="12">'.implode("\n",$adressen).'</textarea>
            <br><span class="red small">Hinweis:</span> <span class="small">Bitte nur eine Adresse pro Zeile</span></td></tr>
            <tr><td>
            <input type="hidden" name="ac" value="'.$in['ac'].'">
            <input type="hidden" name="ch_cat_abon" value="'.$in['ed_cat'].'">
            <input type="submit" name="btn" value="speichern"></td></tr>
            </form>
            </table>
			</div>
            <br>
        ';
	}
	site_footer();
}

function dele_cat($categorie){
	global $script_pfad, $cat, $ISDEMO;
	if($categorie == '') fehler("Kategorie \"$categorie\" konnte nicht gel&ouml;scht werden!");
	if($script_pfad == '') fehler("Bitte stellen Sie zuerst den Script Pfad unter \"Script Optionen\" ein!");
	if(!is_writeable("$script_pfad/protected")) fehler("Script Pfad \"$script_pfad/protected\" ist schreibgesch&uuml;tzt!<br>Versuchen Sie es mit den Rechten 775 oder 777! ;-)");


	if(!$ISDEMO){
		$var  = "<?php\n" ;
		for($x=0;$x<sizeof($cat);$x++) { 
			if(key($cat) != $categorie){  
				$key = key($cat);
				if(!isset($catVisibility[$key]))$catVisibility[$key]='public';
				$var .= "\$cat['".$key."'] = \"".$cat[$key]."\";\n";
				$var .= "\$catVisibility['".$key."'] = \"".$catVisibility[$key]."\";\n";
			}
			next($cat);  
		}
		$var .= "?>\n";
		
		store($script_pfad."/protected/kategorien.php",$var);
		fileDelete("$script_pfad/protected/abonnenten/$categorie.txt");
	}
	##
	## letters aus der kategorie m&uuml;ssen noch gel&ouml;scht werden!!!!!
	##

	header("Location: admin.php?ac=kategorien");
}

function new_cat($in,$ch){
	global $script_pfad, $cat, $catVisibility, $ISDEMO;

	if($script_pfad == '') fehler("Bitte stellen Sie zuerst den Script Pfad unter \"Script Optionen\" ein!");
	if(!is_writeable("$script_pfad/protected")) fehler("Script Pfad \"$script_pfad/protected\" ist schreibgesch&uuml;tzt!<br>Versuchen Sie es mit den Rechten 775 oder 777! ;-)");

	if($ch == '0'){
		$cat[$in['catName']]= (!isset($cat[$in['catName']])) ? '' : $cat[$in['catName']];
		if($cat[$in['catName']] != '') fehler("Kategoriename \"".$in['catName']."\" existiert bereits!");

		$cat[$in['catName']]=$in['catCaption'];
		$catVisibility[$in['catName']] = $in['catVisibility'];
	}
	if($ch == 'ch'){
		$cat[$in['catName']]=$in['catCaption'];
		$catVisibility[$in['catName']] = $in['catVisibility'];
	}
	
	if(!$ISDEMO){
		$var  = "<?php\n" ;
		for($x=0;$x<sizeof($cat);$x++) {
			$key = key($cat);
			$val = $cat[$key];
            
			if(!isset($catVisibility[$key]))$catVisibility[$key]='public';
			
            $val = get_magic_quotes_gpc() ? stripslashes($val) : $val;
			$val = str_replace('\\', '\\\\', $val);
			$val = str_replace('"', '\\"', $val);
            
			$var .= "\$cat['".$key."'] = \"".$val."\";\n";
			$var .= "\$catVisibility['".$key."'] = \"".$catVisibility[$key]."\";\n";
			next($cat);
		}
		$var .= "?>\n";

		
		if(!file_exists("$script_pfad/protected/abonnenten/".$in['catName'].".txt")){
			store("$script_pfad/protected/abonnenten/".$in['catName'].".txt","");
		}

		if(!file_exists("$script_pfad/protected/letters/".$in['catName'].".idx")){
			store("$script_pfad/protected/letters/".$in['catName'].".idx","");
		}

		store($script_pfad."/protected/kategorien.php",$var);
	}
	
	header("Location: admin.php?ac=kategorien");
}

function store_vars($in){
	global $ISDEMO;
	#pr&uuml;fe den pfad, wenn falsch gebe fehler aus
	if(!is_dir($in['script_pfad'])) fehler("Script Pfad \"".$in['script_pfad']."\" ist falsch oder nicht angegeben!");

	if(!is_writeable($in['script_pfad']."/protected")){fehler("Script Verzeichnis \"".$in['script_pfad']."/protected\" ist schreibgesch&uuml;tzt!<br>Versuchen Sie es mit den Rechten 775 oder 777! ;-)");}
	if(!is_writeable($in['script_pfad']."/protected/data")){fehler("Script Verzeichnis \"".$in['script_pfad']."/protected/data\" ist schreibgesch&uuml;tzt!<br>Versuchen Sie es mit den Rechten 775 oder 777! ;-)");}
	
	if(!$ISDEMO){
		mk_dir($in['script_pfad']."/protected/data");
		mk_dir($in['script_pfad']."/protected/data/ses");
		mk_dir($in['script_pfad']."/protected/data/templates");
		mk_dir($in['script_pfad']."/protected/letters");
		mk_dir($in['script_pfad']."/protected/abonnenten");
		mk_dir($in['script_pfad']."/protected/plugins");
		
		$var  = "<?php\n" ;
		for($x=0;$x<sizeof($in);$x++) {
            $key = key($in);
            $val = current($in);
			if($key == 'ac') continue;
			if($key == 'btn') continue;
			
            $val = get_magic_quotes_gpc() ? stripslashes($val) : $val;
			$val = str_replace('\\', '\\\\', $val);
			$val = str_replace('"', '\\"', $val);
            
			$var .= "\$".$key." = \"".$val."\";\n";
			next($in);
		}
		if(!class_exists("NSLNoCopyright", false))
		{
			$var .= "\$wtrmrk        = \"PGEgaHJlZj0iaHR0cDovL3d3dy5nNS1zY3JpcHRzLmRlIiB0YXJnZXQ9Il9ibGFuayIgc3R5bGU9ImZvbnQtZmFtaWx5OiBBcmlhbDsgZm9udC1zaXplOiAxMXB4OyIgdGl0bGU9Ikc1LVNjcmlwdHMgTmV3c2xldHRlciBQSFAgU2NyaXB0Ij5Qb3dlcmVkIGJ5IE5ld3NsZXR0ZXIgUEhQPC9hPg==\";\n";
		}
		$var .= "?>\n";
		
		store("variablen.php", $var);
	}
	
	header("Location: admin.php?ac=setup");
}

function plugins(){
	global $script_url, $script_pfad, $cat;
	
	site_header("Erweiterungen", "Plugin16");
	
	print '<div id="pluginAreaMenu"></div>';
	print '<div id="pluginArea"></div>';
	
	site_footer();
}

function password() {
	site_header("Administrator Kennwort einstellen/&auml;ndern", "Key16");

	print '
			<div class="content" style="width: 270px; margin-left: auto; margin-right: auto;">
			<table width="100%" border="0" cellspacing="0" cellpadding="2">
			<form name="form1" method="post" action="admin.php">
			<tr><td colspan="2">&nbsp;</td></tr>
			<tr><td>Benutzername:</td><td><input type="text" name="username"></td></tr>
			<tr><td>Kennwort:</td><td><input type="text" name="password"></td></tr>
			<tr><td>&nbsp;</td><td><input type="hidden" name="ac" value="ch_pass"><input type="submit" name="btn" value="speichern"></td></tr>
			</form>
			</table>
			</div>		   
    ';

	site_footer();
}

function ch_pass($in){
	global $ISDEMO;

	if(!$ISDEMO){
		if($_SERVER['PATH_TRANSLATED']){$htpasswd =$_SERVER['PATH_TRANSLATED'];}
		if($_SERVER['SCRIPT_FILENAME']){$htpasswd =$_SERVER['SCRIPT_FILENAME'];}
		$htpasswd = preg_replace("/\\\\/","/",$htpasswd);
		$htpasswd = preg_replace("/\/\//","/",$htpasswd);
		$htpasswd = preg_replace("/\/admin.php/","/.htpasswd",$htpasswd);


		$passstring = $in['username'].":".crypt($in['password'],"Cd")."\n";
		store($htpasswd, $passstring);

		if($_SERVER['PATH_TRANSLATED']){$htaccess =$_SERVER['PATH_TRANSLATED'];}
		if($_SERVER['SCRIPT_FILENAME']){$htaccess =$_SERVER['SCRIPT_FILENAME'];}
		$htaccess = preg_replace("/\/.htpasswd/","/.htaccess",$htpasswd);

		$accesstxt  = "AuthName \"Administrator Login\"\n";
		$accesstxt .= "AuthType Basic\n";
		$accesstxt .= "AuthUserFile $htpasswd\n";
		$accesstxt .= "AuthGroupFile \/dev\/null\n";
		$accesstxt .= "require valid-user\n";
		store($htaccess,$accesstxt);
	}
	
	header("Location: admin.php");
}

################################################################################
function site_header($site_titel, $stylename) {
	global	$ISDEMO, $script_pfad, $script_url, $cat, $headerExt;
	
	$demo = $ISDEMO ? " - DEMO " : "";
	
	print '
	<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
	<html>
    <head>
    <title>Newsletter PHP</title>
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<link href="style/style.css" rel="stylesheet" type="text/css">
	<script src="style/jquery.js" type="text/javascript"></script>
	<script src="style/jquery.corner.js" type="text/javascript"></script>
	<script src="style/main.js" type="text/javascript"></script>
    <script src="tinymce/tiny_mce.js" type="text/javascript"></script>
	'.$headerExt.'
	</head>
	';
	
	
	print '
    <body bgcolor="#FFFFFF" text="#000000" leftmargin="0" topmargin="0" rightmargin="0" bottommargin="0" marginwidth="0" marginheight="0">
	<div id="mainBox">
		<table height="100%" id="maintable">
		<tr><td valign="top" id="headline">
			<div style="float: left;">G5-Scripts.de PHP Newsletter Script v'.VERSION.$demo.'</div>
			<div style="float: right;">Release: '.RELEASEDATE.'</div>
		</td></tr>
		<tr><td height="100%" valign="top">
			<div id="menu">
				<a href="admin.php" class="Home16">Start</a>
				<a href="admin.php?ac=setup" class="Setup16">Optionen</a>
	';
	
	if(isset($script_pfad) && strlen($script_pfad) > 0 && isset($script_url) && strlen($script_url) > 0){
		print '<a href="admin.php?ac=kategorien" class="CAT16">Kategorien</a>';
		
		if(isset($cat)){
			print '
				<a href="admin.php?ac=email_templ" class="VAR16">E-Mail Templates</a>
				<a href="admin.php?ac=neue_newsletter" class="ReportEdit16">Neuer Newsletter</a>
				<a href="admin.php?ac=letterarchiv" class="Report16">Letterarchiv</a>
				<a href="admin.php?ac=abonnenten" class="Users16">Abonnenten</a>
				<a href="admin.php?ac=plugins" class="Plugin16">Erweiterungen</a>
				<a href="admin.php?ac=password" class="Key16">Kennwort</a>
				';		
		}
	}
	
	print '
			</div>
			<div id="contentBox">
				<span id="contentBoxTitle" class="'.$stylename.'">'.$site_titel.'</span>
    ';
}

function site_footer() {
	$arr = explode('.', RELEASEDATE);
	$jahr = $arr[2];
	print '
		</div>
	</td></tr>
	</table>
	<div id="footline"><a href="http://www.g5-scripts.de" target="_blank">&copy; 2004-'.$jahr.' G5-Scripts.de</a></div>
	</div>
	</body>
	</html>
	';
	exit;
}

function fehler($msg){
	site_header("Es ist ein Fehler aufgetreten","Error16");
	print '<div class="content">
			<div>'.$msg.'</div>
		</div>
	';
	site_footer();
}


################################################################################
function send_letter_admin($in){
	global $sender, $mail_header, $mail_footer, $ISDEMO;
	
	if($in['betreff'] == '') {
		echo "Bitte geben Sie einen Betreff an!";
		exit;
	}
	
	$in['mail_header'] = $mail_header;
	$in['mail_footer'] = $mail_footer;
	
	if(!$ISDEMO){
		$arrTextFields = array('betreff', 'mailtext', 'mail_header', 'mail_footer');
		foreach($arrTextFields as $field){
			if(!isset($in[$field]))		$in[$field] = '';
			if(get_magic_quotes_gpc())	$in[$field] = stripslashes($in[$field]);
		}
		
		$mailtext = '';
		$mailtext .= $in['mail_header'];
		$mailtext .= $in['mailtext'];
		$mailtext .= $in['mail_footer'];
		
		$mailtext = str_replace("<!--abmeldelink-->", "--Abmeldelink erkannt--", $mailtext);
		$mailtext = str_replace("&lt;!--abmeldelink--&gt;", "--Abmeldelink erkannt--", $mailtext);
		$mailtext = str_replace("<!--archiveLink-->", "--ArchiveLink erkannt--", $mailtext);
		$mailtext = str_replace("&lt;!--archiveLink--&gt;", "--ArchiveLink erkannt--", $mailtext);
		
		$mailtext = cutNoArchiveTags($mailtext);
		
		$res = sendmail($sender, $in['betreff'], $mailtext);
		if(!$res){
			echo "Fehler beim Versenden der E-Mail!";
			exit;
		}
	}
	
	echo "Newsletter verschickt an $sender";
	exit;
}
/**
 * Sendet ein Newsletter an eine User E-Mail Adresse
 * 
 * @param 	string $addr	E-Mail Adresse
 * @param 	string $cat		Name des Kategorie
 * @param 	int $nslID		ID des Newsletters
 *
 * @return bool
 */
function sendLetterToUser($addr, $catID, $nslID){
	global $script_pfad, $script_url, $cat;
	
	$adresse = preg_replace("/(\015\012)+|(\015)+|(\012)+/i","",$addr);
	
	if(strlen($addr) == 0) return "";
	if(strlen($catID) == 0) return "";
	if(!is_numeric($nslID)) return "";
	
	if(!$ISDEMO){
		$letter = new NSLetter("$script_pfad/protected/letters/", $nslID);
		$letter->Load();

		$categorien=array();
		foreach($letter->categorie as $c){
			array_push($categorien, $cat[$c]);
		}
		
		$betreff = $letter->subject;
		
		$mailtext = '';
		$mailtext .= $letter->header;
		$mailtext .= $letter->message;
		$mailtext .= $letter->footer;

		$abmeldeLink = $script_url."/newsletter.php?ac=austragen&cat=".$catID."&email=".$adresse;
		$mailtext = str_replace("<!--abmeldelink-->", $abmeldeLink, $mailtext);
		$mailtext = str_replace("&lt;!--abmeldelink--&gt;", $abmeldeLink, $mailtext);
		
		$archiveLink = $script_url."/archive.php?show=".$nslID;
		$mailtext = str_replace("<!--archiveLink-->", $archiveLink, $mailtext);
		$mailtext = str_replace("&lt;!--archiveLink--&gt;", $archiveLink, $mailtext);
		
		$mailtext = str_replace("<!--cats-->", implode(',', $categorien), $mailtext);
		$mailtext = str_replace("&lt;!--cats--&gt;", implode(',', $categorien), $mailtext);

		if(isset($cat[$catID])){
			$mailtext = str_replace("<!--cat-->", $cat[$catID], $mailtext);
			$mailtext = str_replace("&lt;!--cat--&gt;", $cat[$catID], $mailtext);
		}
		
		$mailtext = cutNoArchiveTags($mailtext);
		
		$res = sendmail($adresse, $betreff, $mailtext);
		if(!$res){
			echo $catID."|".$addr."|".$nslID."|0";	
			return;
		}
	}
	
	echo $catID."|".$addr."|".$nslID."|1";	
}

function cutNoArchiveTags($inhalt){
	/* ----- <archive>-tags suchen und samt inhalt rausschneiden ------ */
	$inhalt = str_replace("&lt;archive&gt;", "<archive>", $inhalt);
	$inhalt = str_replace("&lt;/archive&gt;", "</archive>", $inhalt);
	
	while(preg_match("-<archive>.*?</archive>-si", $inhalt, $results)){
		for($x=0;$x<sizeof($results);$x++) {
			$inhalt = str_replace($results[$x], "", $inhalt);
		}
	}

	/* ----- <noarchive>-tags suchen und rausschneiden (inhalt belassen) ------ */
	$inhalt = str_replace("&lt;noarchive&gt;", "", $inhalt);
	$inhalt = str_replace("&lt;/noarchive&gt;", "", $inhalt);
	$inhalt = str_replace("<noarchive>", "", $inhalt);
	$inhalt = str_replace("</noarchive>", "", $inhalt);	
	
	return $inhalt;
}

function saveLetter($in){
	global $script_pfad, $mailformat, $mail_header, $mail_footer, $ISDEMO;
	
	$nslID = time();
	$in['mail_header'] = $mail_header;
	$in['mail_footer'] = $mail_footer;
	
	$arrTextFields = array('betreff', 'mailtext', 'mail_header', 'mail_footer');
	foreach($arrTextFields as $field){
		if(!isset($in[$field]))		$in[$field] = '';
		if(get_magic_quotes_gpc())	$in[$field] = stripslashes($in[$field]);
	}
	
	#email an user
	$str='';
	if(!$ISDEMO){
		if(!isset($in['categorie'])){$in['categorie']=array();}

		$letter = new NSLetter("$script_pfad/protected/letters/", $nslID);
		$letter->categorie = $in["categorie"];
		$letter->format = $mailformat;
		$letter->subject = $in['betreff'];
		$letter->message = $in['mailtext'];
		$letter->header = $in['mail_header'];
		$letter->footer = $in['mail_footer'];
		
		$letter->Save();
		
		foreach($in["categorie"] as $cat){
			if(strlen($cat) > 0){
				$adressen = saEMailAddress($cat);
				foreach($adressen as $adr)
					if(strlen($adr) > 0 && is_numeric($nslID))
						$str .= trim($cat) ."|".trim($adr)."|".trim($nslID)."\n";
				
				store("$script_pfad/protected/letters/$cat.idx",$nslID."|".$in['betreff']."|0\n","a+");
			}
		}
	}
	echo $str;
	exit;
}

function LoadPlugins(){
	global $script_pfad, $script_url, $headerExt;
	
	$headerExt='';
	$pluginsPath = "plugins";
	$pluginsUrl  = "plugins";
	
	if(is_dir($pluginsPath)){
		if(!is_readable($pluginsPath)){
			fehler("Kann aus dem Verzeichnis \"$pluginsPath\" nicht lesen!");
		}else{
			$dir = opendir($pluginsPath);
			while ($elem = readdir($dir)) {
				if(!preg_match('/^\./', $elem)) {
					$pluginDir = $pluginsPath."/".$elem;
					$pluginUrl = $pluginsUrl."/".$elem;
					if(is_dir($pluginDir)){
						$subDir = opendir($pluginDir);
						while ($file = readdir($subDir)) {
							if(!preg_match('/^\./', $file)) {
								if(preg_match("/plugin.php/", strtolower($file))){
									include($pluginDir."/".$file);
								}						
								if(preg_match("/plugin.css/", strtolower($file))){
									$headerExt.='<link href="'.$pluginUrl.'/'.$file.'" rel="stylesheet" type="text/css">'."\n";
								}
								if(preg_match("/plugin.js/", strtolower($file))){
									$headerExt.='<script src="'.$pluginUrl.'/'.$file.'" type="text/javascript"></script>'."\n";
								}
							}		
						}
						closedir($subDir);
					}				
				}
			}
			closedir($dir);
		}
	}
	return $headerExt;
}

?>