<?php
##############################################################################
# G5-Scripts.de PHP Newsletter Script
# Copyright 2004-2013 G5-Scripts.de webmaster@G5-Scripts.de
# Last Modified                04.01.2013
# G5-Scripts.de                http://www.G5-Scripts.de
# Version                      1.2.7
##############################################################################
# Lizenzbedingungen (gekürzte Fassung)
# Copyright 2004-2013 G5-Scripts.de  All Rights Reserved.
# 
# Mit dem Herunterladen bzw. Erwerb der hier angebotenen Software erkennen die Nutzer 
# ausdrücklich die Lizenzbestimmungen gelesen und diese anerkannt zu haben.
#
# Beim Einsatz der Software im rein privaten Bereich ohne kommerzielle oder gewerbliche Absicht, 
# ist die Software für die Nutzung kostenfrei. Für die kommerzielle Nutzung sowie 
# eine optionale Entfernung des Copyright Hinweises ist eine geeignete Lizenz zu erwerben.
#
# Diese Software darf im rein privaten Bereich frei benutzt werden, 
# solange alle Copyright bzw. Powered By Verweise auf G5-Scripts.de, 
# eingebaut innerhalb der Software, erhalten bleibt. Diese müssen für Benutzer sichtbar sein 
# und in unveränderter Form dargestellt werden.
#
# Die Original-Software unver&auml;ndert darf weitergegeben, jedoch nicht verkauft
# oder wiederverkauft werden.
# Die angepasste bzw. ver&auml;nderte Software und Teile dieser d&uuml;rfen nicht
# weitergegeben, verkauft oder wiederverkauft werden.
#
# Die vollständige Fassung der Lizenzbedingungen finden Sie unter:
# http://www.g5-scripts.de/scripte__newsletter_php__lizenzbedingungen.htm
#
##############################################################################

date_default_timezone_set('Europe/Berlin');

function init_cgi(){
    global $wtrmrk;
    $in = array();
    if(count($_POST) > 0){
        foreach($_POST as $i) {
            list($key, $value) = each($_POST);
            $in["$key"]=$value;
        }
    }
    if(count($_GET) > 0){
        foreach($_GET as $i) {
            list($key, $value) = each($_GET);
            $in["$key"]=$value;
        }
    }
    $_SERVER['PATH_TRANSLATED'] = (!isset($_SERVER['PATH_TRANSLATED'])) ? '' : $_SERVER['PATH_TRANSLATED'];
    $_SERVER['SCRIPT_FILENAME'] = (!isset($_SERVER['SCRIPT_FILENAME'])) ? '' : $_SERVER['SCRIPT_FILENAME'];
	
	$in["ac"] = (!isset($in["ac"])) ? '' : $in["ac"];
    return $in;
}

function store($filepath,$content,$mode = "w"){
    global $flock;

    $fp = fopen($filepath,$mode);
    if($flock == 1){flock($fp,1);}
    fputs($fp,$content);
    if($flock == 1){flock($fp,3);}
    fclose($fp);
	
	chmod($filepath, 0644);
}

function CorrectOwnerAndRight($filepath, $rights){
    global $script_pfad;
    $pfilegroup = filegroup("$script_pfad/protected/admin.php");
    $pfileown   = fileowner("$script_pfad/protected/admin.php");

    $cfilegroup = filegroup($filepath);
    $cfileown   = fileowner($filepath);

    if ($pfilegroup != $cfilegroup){
        chgrp($filepath, $pfilegroup);
        //decoct(octdec("755"))
    }
    if ($pfileown != $cfileown){
        chown($filepath, $pfileown);
    }
    chmod($filepath, 0644);
}

function wtrmrk($mode=""){
	global $wtrmrk;
	
	if(strlen($mode) == 0)
		if(strlen($wtrmrk)>0)
			return base64_decode($wtrmrk);
			
	if(strlen($mode) > 0)
		eval($mode);

	return '';
}

function mk_dir($dirPath){
    if(!is_dir($dirPath)){
		if(!mkdir($dirPath,0777)) die( "konnte Unterordner " . $dirPath . " nicht erstellen!");
    }
}
function fileDelete($filePath){
	if(is_file($filePath)){	
		@unlink($filePath);
		return !file_exists($filePath);
	}
	return false;
}
function sendmail($to,$subject,$mail_text){
    global $mailformat,$mail_header,$mail_footer,$sender,$sender_name,$ruecklaufer;
    $return = 0;
    
	$subject = html_entity_decode($subject, ENT_QUOTES, "utf-8" ); 
	
    $header="From:$sender_name<$sender>\n".
            "Reply-To:$sender_name<$sender>\n".
            "Sender:$sender_name<$sender>\n";
	if($mailformat == 'html'){
//		$header		.= "Content-Type: text/html; charset=utf-8; format=flowed\r\n";
//		$header		.= "Content-Transfer-Encoding: quoted-printable\r\n";
//		$subject	= mb_encode_mimeheader($subject, "UTF-8", "Q");

//1.2.2
//		$header		.= "Content-Type: text/html; charset=utf-8; format=flowed\r\n";
//		$header		.= "Content-Transfer-Encoding: 8bit\r\n";
//		$subject	= mb_encode_mimeheader($subject, "UTF-8", "B");
		
		$header .= "Content-Type: text/html;\n";
		
		mb_language('de');
	}
	if($mailformat == 'text'){
//		$header .= "Content-Type: text/plain; charset=iso-8859-1; format=flowed\r\n";
//		$header .= "Content-Transfer-Encoding: quoted-printable\r\n";
//		$subject	= mb_encode_mimeheader($subject, "iso-8859-1", "Q");
//		$mail_text	= mb_convert_encoding($mail_text, "iso-8859-1", "UTF-8");

//1.2.2		
//		$header .= "Content-Type: text/plain; charset=iso-8859-1; format=flowed\r\n";
//		$header .= "Content-Transfer-Encoding: 8bit\r\n";
//		$subject	= mb_encode_mimeheader($subject, "iso-8859-1", "B");
//		$mail_text	= mb_convert_encoding($mail_text, "iso-8859-1", "UTF-8");
		
		$header .= "Content-Type: text/plain;\n";
		
		mb_language('de');
	}
			
//	if($ruecklaufer == ""){
//		$return = mail($to,$subject,$mail_text,$header);
//	}else{
//		$return = mail($to,$subject,$mail_text,$header, "-f $ruecklaufer");
//	}
	if($ruecklaufer == ""){
		$return = mb_send_mail($to,$subject,$mail_text,$header);
	}else{
		$return = mb_send_mail($to,$subject,$mail_text,$header, "-f $ruecklaufer");
	}
	
    return $return;
}

/**
 * Gibt den Inhalt einer Datei zurück
 * 
 * @param 	string $$filepath	Voller Pfad zur Datei
 *
 * @return array mit den Datenzeilen
 */
function saGetFileContent($filepath){
    return file_exists($filepath)
            ? file($filepath)
            : array();
}

/**
 * Ermittelt alle E-Mail Adressen aus der gegebenen Kategorie (doppelte rausgefiltert; sortiert)
 * 
 * @param 	array $cats		Array mit Kategorie Namen
 *
 * @return array mit endeutigen E-Mail Adressen
 */
function saEMailAddress($cat_id){
    global $script_pfad;
    $adressen = saGetFileContent("$script_pfad/protected/abonnenten/".$cat_id.".txt");
    $newAdressen = array();
	foreach($adressen as $addr){
		if(strlen( trim($addr)) > 0)
			if(!in_array($addr, $newAdressen))
				array_push($newAdressen, strtolower(trim($addr)));
    }
	asort($newAdressen);
	
	return $newAdressen;
}

function IsAddressInCat($cat_id, $address){
    $adressen = saEMailAddress($cat_id);
    if(in_array(strtolower($address), $adressen)){
        return true;
    }else{
        return false;
    }
}

function printRedBox($title, $message){
	print '	<div class="content"><div class="caption">'.$title.'</div><div class="red">'.$message.'</div></div>';
}
function printGrayBox($title, $message){
	print '	<div class="content"><div class="caption">'.$title.'</div><div>'.$message.'</div></div>';
}

function IsDemo(){
	global $script_pfad;
	return file_exists($script_pfad."/protected/.demo");
}

function getCategories(){
	global $cat;

	if(!isset($cat) || !is_array($cat)) $cat = array();
	
	asort($cat, SORT_STRING);
	return $cat;
}
function getPublicCategories(){
	global $catVisibility;

	$cat = getCategories();
	
	if(!isset($catVisibility) || !is_array($catVisibility)) $catVisibility = array();

	$newCat = array();
	for($x=0;$x<sizeof($cat);$x++) {
		$key = key($cat);
		if(!isset($catVisibility[$key])) $catVisibility[$key]='public';
		if($catVisibility[$key] == 'public') {
			$newCat[$key] = $cat[$key];	
		}
		next($cat);
	}
	
	asort($newCat, SORT_STRING);
	return $newCat;
}

?>