<?php
##############################################################################
# G5-Scripts.de PHP Newsletter Script
# Copyright 2004-2013 G5-Scripts.de webmaster@G5-Scripts.de
# Last Modified                04.01.2013
# G5-Scripts.de                http://www.G5-Scripts.de
# Version                      1.2.7
##############################################################################
# Lizenzbedingungen (gekürzte Fassung)
# Copyright 2004-2013 G5-Scripts.de  All Rights Reserved.
# 
# Mit dem Herunterladen bzw. Erwerb der hier angebotenen Software erkennen die Nutzer 
# ausdrücklich die Lizenzbestimmungen gelesen und diese anerkannt zu haben.
#
# Beim Einsatz der Software im rein privaten Bereich ohne kommerzielle oder gewerbliche Absicht, 
# ist die Software für die Nutzung kostenfrei. Für die kommerzielle Nutzung sowie 
# eine optionale Entfernung des Copyright Hinweises ist eine geeignete Lizenz zu erwerben.
#
# Diese Software darf im rein privaten Bereich frei benutzt werden, 
# solange alle Copyright bzw. Powered By Verweise auf G5-Scripts.de, 
# eingebaut innerhalb der Software, erhalten bleibt. Diese müssen für Benutzer sichtbar sein 
# und in unveränderter Form dargestellt werden.
#
# Die Original-Software unver&auml;ndert darf weitergegeben, jedoch nicht verkauft
# oder wiederverkauft werden.
# Die angepasste bzw. ver&auml;nderte Software und Teile dieser d&uuml;rfen nicht
# weitergegeben, verkauft oder wiederverkauft werden.
#
# Die vollständige Fassung der Lizenzbedingungen finden Sie unter:
# http://www.g5-scripts.de/scripte__newsletter_php__lizenzbedingungen.htm
#
##############################################################################

if(file_exists("variablen.php")){include("variablen.php");}

$output		= '';
$delimiter	= "\n";

$output .= 'var tinyMCEImageList = new Array(';

$directory = $script_pfad."/userfiles/image"; // Use your correct (relative!) path here
$imageDirURL = $script_url."/userfiles/image";

if (is_dir($directory)) {
	$direc = opendir($directory);

	while ($file = readdir($direc)) {
		if (!preg_match('/^\./', $file)) { // no hidden files / directories here...
			if (is_file("$directory/$file") && getimagesize("$directory/$file") != FALSE) {
				$output .= $delimiter
					. '["'
					. utf8_encode($file)
					. '", "'
					. utf8_encode("$imageDirURL/$file")
					. '"],';
			}
		}
	}

	if(substr($output, strlen($output)-1, 1)== ','){
		$output = substr($output, 0, -1); // letztes komma entfernen
	}
	$output .= $delimiter;

	closedir($direc);
}

$output .= ');';

// JavaScript Header ausgeben!
header('Content-type: text/javascript'); // browser will now recognize the file as a valid JS file

// Browser Cachen verhindern
header('pragma: no-cache');
header('expires: 0');

// ausgabe
echo $output;
exit;

?>